# CodeOptimization

The best way to write a code called as code optimization. The best ways are ruby styleguide, rails styleguide, code reusability, without code duplication, without security vulnerabilities and without N+1 queries. The above each and every best ways are have some libraries.

## Combination Of Below Gems

1. OVERCOMMIT(Git Hook Manager)
2. RUBOCOP(STATIC CODE ANALYSIS)
3. BULLET(N+1 Query)
4. BRAKEMAN(SECURITY SCANNER FOR ROR APPLICATION)
5. Rack Mini profiler(Middleware that displays speed badge)
6. Rails Best Practises(Rails Code Analysis Tool)
7. RubyCritic(Ruby Code quality reporter)

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'code_optimization'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install code_optimization
    
## SETUP Details are Below

[Code Optimization Document](https://github.com/honestveera/code_optimization/blob/master/code_optimization.md).

## Usage

TODO: Write usage instructions here

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/honestveera/code_optimization. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the CodeOptimization project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/code_optimization/blob/master/CODE_OF_CONDUCT.md).
